;/*
; * Missile Command
; */

;/* Terror */
Type TMissile
	Field x0
	Field y0
	
	Field x#
	Field y#
	
	Field vx#
	Field vy#
End Type

Function newTMissile.TMissile()
	Local m.TMissile = New TMissile
	
	m\x0 = Rnd( 50, 750 )
	m\y0 = 0
	
	m\x = m\x0
	m\y = m\y0
	
	Local target = Rand(0, 1)
	Local getOut
	
	If target = 0
		getOut = True
		For i = 0 To 2
			If baseAlive[i]
				getOut = False
			EndIf
		Next
		If getOut
			target = 1
		EndIf
	EndIf
	
	If target = 1
		getOut = True
		For i = 0 To 5
			If cityAlive[i]
				getOut = False
			EndIf
		Next
		If getOut
			target = 2
		EndIf
	EndIf
	
	If target <> 2
		If target = 0
			target = Rand(0, 2)
			While Not baseAlive[ target ]
				target = Rand(0, 2)
			Wend
			
			m\vx = selPosX[ target ] +92 - m\x
			m\vy = 573 - 0
		ElseIf target = 1
			target = Rand(0, 5)
			While Not cityAlive[ target ]
				target = Rand(0, 5)
			Wend
			
			m\vx = cityPosX[ target ] +25 - m\x
			m\vy = 563 - 0
		EndIf
		
		Local invVl# = 1./Sqr( m\vx*m\vx + m\vy*m\vy ) * Rnd(0.8, 1.2)
		
		m\vx = m\vx * invVl
		m\vy = m\vy * invVl
	Else
		Delete m
	EndIf
	
	Return m
End Function

Function updateTMissile( m.TMissile )
	m\x = m\x + m\vx
	m\y = m\y + m\vy
	
	If m\x < 0
		Delete m
	ElseIf m\x > 800
		Delete m
	ElseIf m\y > 575
		newTExplosion(m\x, m\y)
		
		For i = 0 To 2
			If RectsOverlap( m\x, m\y, 1, 1, selPosX[i], 547, 184, 52 )
				baseAlive[i] = False
			EndIf
		Next
		
		For i = 0 To 5
			If RectsOverlap( m\x, m\y, 1, 1, cityPosX[i], 538, 50, 50)
				cityAlive[i] = False
			EndIf
		Next
		
		Delete m
	EndIf
End Function

Function drawTMissile( m.TMissile )
	If m = Null
		Return
	EndIf
	
	Color 255, 0, 0
	
	Line m\x, m\y, m\x0, m\y0
	
	Color 255, 255, 0
	
	Rect m\x-1, m\y-1, 2, 2
End Function

Type TExplosion
	Field x
	Field y
	
	Field r#
End Type

Function newTExplosion.TExplosion( x#, y# )
	Local e.TExplosion = New TExplosion
	
	e\x = x
	e\y = y
	
	e\r = 0
	
	Return e
End Function

Function updateTExplosion( e.TExplosion )
	e\r = e\r + 1.5
	
	If e\r > 35
		Delete e
	EndIf
End Function

Function drawTExplosion( e.TExplosion )
	If e = Null
		Return
	EndIf
	
	Color 255, 0, 0
	
	Oval e\x - e\r, e\y - e\r, e\r *2, e\r *2
End Function

;/* Counter Terror */
Type CMissile
	Field x0
	Field y0
	
	Field x#
	Field y#
	
	Field vx#
	Field vy#
	
	Field targetX#
	Field targetY#
End Type

Function newCMissile.CMissile( sel, tX#, tY# )
	Local m.CMissile = New CMissile
	
	m\x0 = selPosX[sel] +92
	m\y0 = 545
	
	m\x = m\x0
	m\y = m\y0
	
	m\targetX = tX
	m\targetY = tY
	
	m\vx = m\targetX - m\x
	m\vy = m\targetY - m\y
	
	Local invVl# = 1./Sqr( m\vx*m\vx + m\vy*m\vy ) *10
	
	m\vx = m\vx *invVl
	m\vy = m\vy *invVl
	
	Return m
End Function

Function updateCMissile( m.CMissile )
	m\x = m\x + m\vx
	m\y = m\y + m\vy
	
	Local dx# = m\targetX - m\x
	Local dy# = m\targetY - m\y
	
	Local dl# = Sqr( dx*dx + dy*dy )
	
	If dl < 11
		newCExplosion(m\targetX, m\targetY)
		
		Delete m
	EndIf
End Function

Function drawCMissile( m.CMissile )
	If m = Null
		Return
	EndIf
	
	Color 0, 0, 255
	
	Line m\x, m\y, m\x0, m\y0
	
	Color 255, 255, 0
	
	Rect m\x-1, m\y-1, 2, 2
End Function

Type CExplosion
	Field x
	Field y
	
	Field r#
End Type

Function newCExplosion.CExplosion( x#, y# )
	Local e.CExplosion = New CExplosion
	
	e\x = x
	e\y = y
	
	e\r = 0
	
	Return e
End Function

Function updateCExplosion( e.CExplosion )
	e\r = e\r + 0.35
	
	Local m.TMissile
	Local dx#, dy#, dl#
	
	For m = Each TMissile
		dx = e\x - m\x
		dy = e\y - m\y
		
		dl = Sqr( dx*dx + dy*dy )
		
		If dl < e\r
			Delete m
		EndIf
	Next
	
	If e\r > 25
		Delete e
	EndIf
End Function

Function drawCExplosion( e.CExplosion )
	If e = Null
		Return
	EndIf
	
	Color 0, 0, 255
	
	Oval e\x - e\r, e\y - e\r, e\r *2, e\r *2
End Function

;/*
; * Game
; */

Global selPosX[3]
Global cityPosX[6]
Global baseAlive[3]
Global cityAlive[6]

SeedRnd( MilliSecs() )

Global started = False
StartGame()

Function StartGame()
	Delete Each TMissile
	Delete Each CMissile
	Delete Each TExplosion
	Delete Each CExplosion
	
	Graphics 800, 600, 0, 2
	SetBuffer BackBuffer()
	
	Local Timer = CreateTimer( 60 )
	
	Local missileTimer
	Local missileTime = 2000
	
	Local t.TMissile
	Local c.CMissile
	
	Local et.TExplosion
	Local ec.CExplosion
	
	Local imgBase = LoadFile("IMG_Base.png")
	Local imgBaseBroken = LoadFile("IMG_BaseBroken.png")
	Local imgSelector = LoadFile("IMG_Selector.png")
	
	selPosX[0] = -7
	selPosX[1] = 312
	selPosX[2] = 622
	
	For i = 0 To 3
		baseAlive[i] = True
	Next
	
	Local selPos = 0
	Local selDist, minSelDist
	
	Local imgCity = LoadFile("IMG_City.png")
	Local imgCityBroken = LoadFile("IMG_CityBroken.png")
	
	cityPosX[0] = 172
	cityPosX[1] = 221
	cityPosX[2] = 270
	cityPosX[3] = 488
	cityPosX[4] = 537
	cityPosX[5] = 586
	
	For i = 0 To 5
		cityAlive[i] = True
	Next
	
	Local dead = False
	Local imgSkull = LoadFile("IMG_Skull.png")
	MidHandle imgSkull
	
	Local key
	Local imgAnyKey = LoadFile("IMG_AnyKey.png")
	MidHandle imgAnyKey
	
	While Not started
		DrawImage imgAnyKey, 400, 300
		
		key = GetKey()
		If key <> 0
			started = True
		EndIf
	Wend
	
	While Not KeyHit(1)
		;/*
		; * Render
		; */
		If Not dead
			Color 255, 201, 14
			Rect 0, 588, 800, 12
			
			For i = 0 To 2
				If baseAlive[i]
					DrawImage imgBase, selPosX[i]-1, 546
				Else
					DrawImage imgBaseBroken, selPosX[i]-1, 546
				EndIf
			Next
			
			If baseAlive[selPos]
				DrawImage imgSelector, selPosX[selPos], 547
			EndIf
			
			For i = 0 To 5
				If cityAlive[i]
					DrawImage imgCity, cityPosX[i], 538
				Else
					DrawImage imgCityBroken, cityPosX[i], 538
				EndIf
			Next
			
			For t = Each TMissile
				updateTMissile( t )
				drawTMissile( t )
			Next
			
			For et = Each TExplosion
				updateTExplosion( et )
				drawTExplosion( et )
			Next	
			
			For c = Each CMissile
				updateCMissile( c )
				drawCMissile( c )
			Next
			
			For ec = Each CExplosion
				updateCExplosion( ec )
				drawCExplosion( ec )
			Next
		Else
			DrawImage imgSkull, 400, 250
			DrawImage imgAnyKey, 400, 500
			
			key = GetKey()
			If key <> 0
				StartGame()
				
				Return
			EndIf
		EndIf
		;/*
		; * Game Update
		; */
		
		If MilliSecs() - missileTimer > missileTime
			newTMissile()
			
			missileTimer = MilliSecs()
		EndIf
		
		dead = True
		For i = 0 To 5
			If cityAlive[i]
				dead = False
			EndIf
		Next
		
		;/*
		; * Steuerung
		; */
		
		If KeyHit(19)
			StartGame()
			Return
		EndIf
		
		;selPos = ( selPos + KeyHit(205) - KeyHit(203) + 3 ) Mod 3
		If Not baseAlive[selPos]
			selPos = ( selPos + 4 ) Mod 3
		EndIf
		If MouseHit(1)
			If MouseY() >= 540
				minSelDist = 800
				
				For i = 0 To 2
					If baseAlive[ i ]
						selDist = Abs( MouseX() - selPosX[i] - ImageWidth(imgSelector)/2 )
						
						If selDist < minSelDist
							minSelDist = selDist
							
							selPos = i
						EndIf
					EndIf
				Next
			Else
				If Not dead
					If baseAlive[ selPos ]
						newCMissile( selPos, MouseX(), MouseY() )
					EndIf
				EndIf
			EndIf
		EndIf
		
		Flip 0
		WaitTimer( Timer )
		Cls
	Wend
End Function

;/*
; * Special Stuff
; */

Function LoadFile( path$ )
	If FileType(path) = 0
		RuntimeError "File "+path+" does not exist."
	EndIf
	
	Local typ$ = Right(path, 3)
	
	Select typ
		Case "png", "bmp", "jpg"
			Return LoadImage(path)
		Default
			DebugLog "Do not know type "+typ
	End Select
End Function
;~IDEal Editor Parameters:
;~C#Blitz3D